@echo off
echo off
if '%KEEP%' == '1' prompt $p +k$g
if exist Mk2013.pif del Mk2013.pif

if not "%PG%" == "" goto PG_OK
 echo/
 echo  Enviroment variable PG does not exist.
 echo/
 echo Execute this '%0'
 echo by 'mk.bat', 'm.bat' or something like that.
 set HIT=1
 goto EndOfBat
:PG_OK

if not '%CPP%' == '1' goto SrcC
 if exist %PG%.cpp set PG2=/TP %PG%.cpp
 if exist %PG%.cpp goto SrcOK
 if exist %PG%.c set PG2=/TP %PG%.c
 if exist %PG%.c goto SrcOK
  echo/
  echo Neither %PG%.c nor %PG%.cpp does exist
  set HIT=1
  goto EndOfBat
:SrcC
  if exist %PG%.c set PG2=%PG%.c
  if exist %PG%.c goto SrcOK
  echo/
  echo %PG%.c does not exist.
  set HIT=1
  goto EndOfBat
:SrcOK

if "%BIT%" == "64" goto BitOK
if "%BIT%" == "32" goto BitOK
 echo/
 echo Error! environment variable BIT is not correct
 echo/
 echo please set BIT=32 or set BIT=64
 set HIT=1
 goto EndOfBat
:BitOK

set P1=C:\Program Files ^(x86^)
set P2=C:\Program Files ^^^(x86^^^)
if "%ProgramFiles(x86)%" == "" set BIT=32
if "%ProgramFiles(x86)%" == "" set P2=C:\Program Files
if "%ProgramFiles(x86)%" == "" set P1=C:\Program Files

set AMD=
set X64=
set L64=
set M64=
set VS=Microsoft Visual Studio 12.0
if not exist "%P1%\%VS%" goto ComNG
if not exist "%P1%\%VS%\VC\bin\x86_amd64\CL.EXE" set BIT2=32
if not "%BIT%" == "64" goto X86
if exist "%P1%\%VS%\VC\bin\x86_amd64\CL.EXE" set AMD=\x86_amd64
if exist "%P1%\%VS%\VC\bin\x86_amd64\CL.EXE" set X64=\amd64
if exist "%P1%\%VS%\VC\bin\x86_amd64\CL.EXE" set L64=\x64
if exist "%P1%\%VS%\VC\bin\x86_amd64\CL.EXE" set M64=\x64
goto Start
:X86
set L64=\x86
:Start
if exist "%P1%\%VS%\VC\BIN%AMD%\CL.EXE" goto ComOK
:ComNG
echo/
echo "%P1%\%VS%\VC\BIN%AMD%\CL.EXE" is not found.
set HIT=1
goto EndOfBat
:ComOK
set SDK=Windows Kits\8.1
set WINV=\winv6.3
if not exist "%P1%\%SDK%\bin" set WINV=\win8
if not exist "%P1%\%SDK%\bin" set SDK=Windows Kits\8.0
PATH %P2%\%VS%\VC\BIN%AMD%;%P2%\%SDK%\bin%L64%;%P2%\%VS%\VC\BIN;%PATH%
set INCLUDE=%P1%\%VS%\VC\INCLUDE;%P1%\%SDK%\Include\um;%P1%\%SDK%\Include\shared
set LIB=%P1%\%VS%\VC\LIB%X64%;%P1%\%SDK%\Lib%WINV%\um%L64%

if     '%CPP%' == '1' echo { %0 %BIT% bit C++ }
if not '%CPP%' == '1' echo { %0 %BIT% bit C }

set OP=%OPTIONSVC% %OP%
if '%HIT%' == '1' set OP=%HIT_OPTIONS% %OP%
set OP=%OPTIONS% %OP%
if     '%OPENMP%'    == '1' set OP=/openmp %OP%
if not '%WINECONFIGDIR%' == '' goto SkipAnlz
 if not '%ANLZ%' == '1' goto SkipAnlz
  set OP=/analyze -DCODE_ANALYSIS %OP%
:SkipAnlz
if not '%WINDOWS%' == '1' set WINDOWS=0
if     '%WINDOWS%' == '1' set OP=-DWINDOWS %OP%
if     '%WD4819%'  == '1' set OP=/wd4819 %OP%

if not '%ASM%' == '1' goto SkipAsm
                       echo cl /nologo /Fa /c /W4 /MT %OP% /GL- %PG2%
"%P1%\%VS%\VC\BIN%AMD%\CL.EXE" /nologo /Fa /c /W4 /MT %OP% /GL- %PG2%
goto SkipManifest
:SkipAsm


if     exist %PG%.rc                      echo rc /nologo /fotemp.res %PG%.rc
if     exist %PG%.rc "%P1%\%SDK%\bin%L64%\rc.exe" /nologo /fotemp.res %PG%.rc
if not exist %PG%.rc call %TOOLS%\AddVer.bat
if not exist %PG%.rc                      echo rc /nologo temp.rc
if not exist %PG%.rc "%P1%\%SDK%\bin%L64%\rc.exe" /nologo temp.rc
if ERRORLEVEL 1 goto SkipManifest

if exist %EXE%.exe del %EXE%.exe
                       echo cl /nologo /Fe%EXE%.exe /W4 /MT %OP% %PG2% %SUBSRCS% /link /IGNORE:4068 %LINKOPT% %LIBSVC% temp.res kernel32.lib user32.lib gdi32.lib comdlg32.lib winmm.lib imm32.lib wininet.lib shell32.lib advapi32.lib comctl32.lib iphlpapi.lib
"%P1%\%VS%\VC\BIN%AMD%\CL.EXE" /nologo /Fe%EXE%.exe /W4 /MT %OP% %PG2% %SUBSRCS% /link /IGNORE:4068 %LINKOPT% %LIBSVC% temp.res kernel32.lib user32.lib gdi32.lib comdlg32.lib winmm.lib imm32.lib wininet.lib shell32.lib advapi32.lib comctl32.lib iphlpapi.lib
if ERRORLEVEL 1 goto SkipManifest

if exist %EXE%.exe.manifest                      echo mt /nologo /manifest %EXE%.exe.manifest /outputresource:%EXE%.exe
if exist %EXE%.exe.manifest "%P1%\%SDK%\bin%L64%\MT.EXE" /nologo /manifest %EXE%.exe.manifest /outputresource:%EXE%.exe
:SkipManifest
if ERRORLEVEL 1 set HIT=1
if exist *.obj del *.obj
if exist %EXE%.exe.manifest del %EXE%.exe.manifest
if exist temp.res del temp.res
if exist temp.rc del temp.rc
if exist *.nativecodeanalysis.xml del *.nativecodeanalysis.xml
if exist RCa????? del RCa?????
if exist vc120.idb del vc120.idb
if exist *.tlh del *.tlh
if exist *.tli del *.tli

:EndOfBat
if '%HIT%' == '1' pause
