@echo off
echo off
if '%KEEP%' == '1' prompt $p +k$g
if exist Mk2022.pif del Mk2022.pif
set MAJOR=2022
set KIT_PATH=Windows Kits\10
set KIT_VER=10.0.22000.0
set VC_VER=14.39.33519

if not "%PG%" == "" goto PG_OK
 echo/
 echo  Enviroment variable PG does not exist.
 echo/
 echo Execute this '%0'
 echo by 'mk.bat', 'm.bat' or something like that.
 set HIT=1
 goto EndOfBat
:PG_OK

if not '%CPP%' == '1' goto SrcC
 if exist %PG%.cpp set PG2=/TP %PG%.cpp
 if exist %PG%.cpp goto SrcOK
 if exist %PG%.c set PG2=/TP %PG%.c
 if exist %PG%.c goto SrcOK
  echo/
  echo Neither %PG%.c nor %PG%.cpp does exist
  set HIT=1
  goto EndOfBat
:SrcC
  if exist %PG%.c set PG2=%PG%.c
  if exist %PG%.c goto SrcOK
  echo/
  echo %PG%.c does not exist.
  set HIT=1
  goto EndOfBat
:SrcOK

if "%BIT%" == "64" goto BitOK
if "%BIT%" == "32" goto BitOK
 echo/
 echo Error! environment variable BIT is not correct
 echo/
 echo please set BIT=32 or set BIT=64
 set HIT=1
 goto EndOfBat
:BitOK

set P1=C:\Program Files ^(x86^)
set P2=C:\Program Files ^^^(x86^^^)
set P3=C:\Program Files
set VSROOT=Microsoft Visual Studio\%MAJOR%
if exist "C:\Program Files\%VSROOT%" goto VSROOT_OK

echo/
dir "C:\Program Files\Microsoft Visual Studio"
echo/
echo Visual C++ %MAJOR% is not installed.
set HIT=1
goto EndOfBat

:VSROOT_OK

set VSEDIT=%VSROOT%\Ultimate
if not exist "C:\Program Files\%VSEDIT%" set VSEDIT=%VSROOT%\Premium
if not exist "C:\Program Files\%VSEDIT%" set VSEDIT=%VSROOT%\Enterprise
if not exist "C:\Program Files\%VSEDIT%" set VSEDIT=%VSROOT%\Professional
if not exist "C:\Program Files\%VSEDIT%" set VSEDIT=%VSROOT%\Community
if not exist "C:\Program Files\%VSEDIT%" set VSEDIT=%VSROOT%\Preview
if exist "C:\Program Files\%VSEDIT%" goto VSEDIT_OK
echo/
dir "C:\Program Files\%VSROOT%"
echo/
echo Visual C++ %MAJOR%'s edition is unknown
echo/
echo Please modify %0.
%WINDIR%\notepad %0
set HIT=1
goto EndOfBat

:VSEDIT_OK
set VSVC=%VSEDIT%\VC\Tools\MSVC

if exist "C:\Program Files\%VSVC%" goto VSVC_OK
echo/
echo Visual Studio %MAJOR% exists. But Visual C++ is not exist.
set HIT=1
goto EndOfBat

:VSVC_OK
set SDK=%KIT_PATH%

if exist "%P1%\%SDK%" goto SDK_OK
echo/
if exist "%P1%\%SDK%\Windows Kits" dir "%P1%\%SDK%\Windows Kits"
if not exist "%P1%\%SDK%\Windows Kits" dir "%P1%\%SDK%"
echo/
echo "%P1%\%SDK%" is not exist.
echo/
echo Please edit %0. And modify KIT_PATH.
%WINDIR%\notepad %0
set HIT=1
goto EndOfBat

:SDK_OK
if not exist "C:\Program Files\%VSVC%\%VC_VER%" set VC_VER=14.39.33519
if not exist "C:\Program Files\%VSVC%\%VC_VER%" set VC_VER=14.38.33130
if not exist "C:\Program Files\%VSVC%\%VC_VER%" set VC_VER=14.37.32822
if not exist "C:\Program Files\%VSVC%\%VC_VER%" set VC_VER=14.36.32532
if not exist "C:\Program Files\%VSVC%\%VC_VER%" set VC_VER=14.35.32215
if not exist "C:\Program Files\%VSVC%\%VC_VER%" set VC_VER=14.34.31933
if not exist "C:\Program Files\%VSVC%\%VC_VER%" set VC_VER=14.33.31629
if not exist "C:\Program Files\%VSVC%\%VC_VER%" set VC_VER=14.32.31326
if not exist "C:\Program Files\%VSVC%\%VC_VER%" set VC_VER=14.31.31103
if not exist "C:\Program Files\%VSVC%\%VC_VER%" set VC_VER=14.30.30705
if not exist "C:\Program Files\%VSVC%\%VC_VER%" set VC_VER=14.30.30706
if     exist "C:\Program Files\%VSVC%\%VC_VER%" goto VS_OK
echo/
dir "C:\Program Files\%VSVC%"
echo above version is not registerd %0.
echo/
echo Please edit %0. And modify VC_VER
echo/
%WINDIR%\notepad %0
set HIT=1
goto EndOfBat

:VS_OK
set VS=%VSVC%\%VC_VER%

if not exist "%P1%\%SDK%\Include\%KIT_VER%" set KIT_VER=10.0.22000.0
if not exist "%P1%\%SDK%\Include\%KIT_VER%" set KIT_VER=10.0.19041.0
if     exist "%P1%\%SDK%\Include\%KIT_VER%" goto KIT_OK
echo/
dir "%P1%\%SDK%\Include"
echo Above folder is not registerd %0.
echo/
echo Please edit %0. And modify KIT_VER.
%WINDIR%\notepad %0
set HIT=1
goto EndOfBat

:KIT_OK

set MAIN_INC=%SDK%\Include\%KIT_VER%
set MAIN_LIB=%SDK%\Lib\%KIT_VER%
if %BIT% == 64 set BIN_PATH=%SDK%\bin\%KIT_VER%\x64
if %BIT% == 32 set BIN_PATH=%SDK%\bin\%KIT_VER%\x86
set INCLUDE=C:\Program Files\%VS%\include;%P2%\%MAIN_INC%\um;%P2%\%MAIN_INC%\ucrt;%P2%\%MAIN_INC%\shared;%P2%\%MAIN_INC%\winrt
if %BIT% == 64 set LIB=%P2%\%MAIN_LIB%\ucrt\x64;%P2%\%MAIN_LIB%\um\x64;C:\Program Files\%VS%\lib\x64
if %BIT% == 32 set LIB=%P2%\%MAIN_LIB%\ucrt\x86;%P2%\%MAIN_LIB%\um\x86;C:\Program Files\%VS%\lib\x86
if %BIT% == 64 set PATH_VS=%VS%\bin\HostX86\x64
if %BIT% == 32 set PATH_VS=%VS%\bin\HostX86\x86
PATH C:\Program Files\%PATH_VS%;%P2%\%BIN_PATH%;%PATH%

if exist "C:\Program Files\%PATH_VS%\cl.exe" goto CL_OK
echo/
echo "C:\Program Files\%PATH_VS%\cl.exe" is not found.
echo/
echo Please modify %0.
%WINDIR%\notepad %0
set HIT=1
goto EndOfBat

:CL_OK

if     '%CPP%' == '1' echo { %0 %BIT% bit C++ }
if not '%CPP%' == '1' echo { %0 %BIT% bit C }

set OP=%OPTIONSVC% %OP%
if '%HIT%' == '1' set OP=%HIT_OPTIONS% %OP%
set OP=%OPTIONS% %OP%
if     '%OPENMP%'    == '1' set OP=/openmp %OP%
if not '%WINECONFIGDIR%' == '' goto SkipAnlz
 if not '%ANLZ%' == '1' goto SkipAnlz
  set OP=/analyze -DCODE_ANALYSIS %OP%
:SkipAnlz
if not '%WINDOWS%' == '1' set WINDOWS=0
if     '%WINDOWS%' == '1' set OP=-DWINDOWS %OP%
if     '%WD4819%'  == '1' set OP=/wd4819 %OP%

if not '%ASM%' == '1' goto SkipAsm
                echo cl /nologo /Fa /c /W4 /wd4464 /MT %OP% /GL- %PG2%
"%P3%\%PATH_VS%\CL.EXE" /nologo /Fa /c /W4 /wd4464 /MT %OP% /GL- %PG2%
goto SkipManifest
:SkipAsm

if     exist %PG%.rc                  echo rc /nologo /fotemp.res %PG%.rc
if     exist %PG%.rc "%P1%\%BIN_PATH%\rc.exe" /nologo /fotemp.res %PG%.rc
if not exist %PG%.rc call %TOOLS%\AddVer.bat
if not exist %PG%.rc                  echo rc /nologo temp.rc
if not exist %PG%.rc "%P1%\%BIN_PATH%\rc.exe" /nologo temp.rc
if ERRORLEVEL 1 goto SkipManifest

if exist %EXE%.exe del %EXE%.exe
                echo cl /nologo /Fe%EXE%.exe /W4 /wd4464 /MT %OP% %PG2% %SUBSRCS% /link /IGNORE:4068 %LINKOPT% %LIBSVC% temp.res kernel32.lib user32.lib gdi32.lib comdlg32.lib winmm.lib imm32.lib wininet.lib shell32.lib advapi32.lib comctl32.lib iphlpapi.lib
"%P3%\%PATH_VS%\CL.EXE" /nologo /Fe%EXE%.exe /W4 /wd4464 /MT %OP% %PG2% %SUBSRCS% /link /IGNORE:4068 %LINKOPT% %LIBSVC% temp.res kernel32.lib user32.lib gdi32.lib comdlg32.lib winmm.lib imm32.lib wininet.lib shell32.lib advapi32.lib comctl32.lib iphlpapi.lib
if ERRORLEVEL 1 goto SkipManifest

if exist %EXE%.exe.manifest                  echo mt /nologo /manifest %EXE%.exe.manifest /outputresource:%EXE%.exe
if exist %EXE%.exe.manifest "%P1%\%BIN_PATH%\MT.EXE" /nologo /manifest %EXE%.exe.manifest /outputresource:%EXE%.exe

:SkipManifest
if ERRORLEVEL 1 set HIT=1
if exist *.obj del *.obj
if exist %EXE%.exe.manifest del %EXE%.exe.manifest
if exist *.nativecodeanalysis.xml del *.nativecodeanalysis.xml
if exist temp.res del temp.res
if exist temp.rc del temp.rc
if exist RCa????? del RCa?????
if exist vc140.idb del vc140.idb
if exist *.tlh del *.tlh
if exist *.tli del *.tli

:EndOfBat
if '%HIT%' == '1' pause
