@echo off
echo off
if '%KEEP%' == '1' prompt $p +k$g
if exist MkGcc.pif del MkGcc.pif

if not "%PG%" == "" goto PG_OK
 echo/
 echo  Enviroment variable PG does not exist.
 echo/
 echo Execute this '%0'
 echo by 'mk.bat', 'm.bat' or something like that.
 set HIT=1
 goto EndOfBat
:PG_OK

if not '%CPP%' == '1' goto SrcC
 set CC=g++
 if exist %PG%.cpp set PG2=%PG%.cpp
 if exist %PG%.cpp goto SrcOK
 if exist %PG%.c set PG2=%PG%.c
 if exist %PG%.c goto SrcOK
  echo/
  echo Neither %PG%.c nor %PG%.cpp does exist
  set HIT=1
  goto EndOfBat
:SrcC
  set CC=gcc
  if exist %PG%.c set PG2=%PG%.c
  if exist %PG%.c goto SrcOK
  echo/
  echo %PG%.c does not exist.
  set HIT=1
  goto EndOfBat
:SrcOK

if "%BIT%" == "64" goto BitOK
if "%BIT%" == "32" goto BitOK
 echo/
 echo Error! environment variable BIT is not correct
 echo/
 echo please set BIT=32 or set BIT=64
 set HIT=1
 goto EndOfBat
:BitOK

if "%ProgramFiles(x86)%" == "" set BIT=32
if '%GCC%' == 'C:\mingw' set GCC=%GCC%%BIT%
if EXIST %GCC%\bin\gcc.exe GOTO ComOK
echo/
echo %GCC%\bin\gcc.exe is not found
echo/
set HIT=1
GOTO EndOfBat
:ComOk
if '%CPP%' == '0' goto ComPPOk
if EXIST %GCC%\bin\g++.exe GOTO ComPPOK
echo/
echo %GCC%\bin\g++.exe is not found
echo/
set HIT=1
GOTO EndOfBat
:ComPPOk
path %GCC%\bin;%PATH%

if     '%CPP%' == '1' echo { %0 %GCC% %BIT% bit C++ }
if not '%CPP%' == '1' echo { %0 %GCC% %BIT% bit C }

goto SkipLinkScript
  echo SECTIONS { > %PG%.x
  echo  .text : { >> %PG%.x
  echo   *(.text) >> %PG%.x
  echo   *(.rdata) >> %PG%.x
  echo   *(SORT(.rdata$*)) >> %PG%.x
  echo } >> %PG%.x
  echo } >> %PG%.x
:SkipLinkScript

set TARGET=
if '%BIT%' == '32' set TARGET=pe-i386
if '%BIT%' == '64' set TARGET=pe-x86-64

set OP=%OPTIONSGC% %OP%
if '%HIT%' == '1' set OP=%HIT_OPTIONS% %OP%
set OP=%OPTIONS% %OP%
set OP=--input-charset=%GCC_INPUT% --exec-charset=%GCC_EXEC% %OP%
if not '%WINDOWS%' == '1' set WINDOWS=0
if     '%WINDOWS%' == '1' set OP=-mwindows -DWINDOWS %OP%
if     '%OPENMP%'  == '1' set OP=-fopenmp %OP%
if     '%OPENMP%'  == '1' set OMPLIB=-lgomp
if not '%OPENMP%'  == '1' set OMPLIB=

if not '%ASM%' == '1' goto SkipAsm
     echo %CC% -Wall -I. -m%BIT% -S -masm=intel %OP% %PG2%
%GCC%\bin\%CC% -Wall -I. -m%BIT% -S -masm=intel %OP% %PG2%
goto SkipCompile
:SkipAsm

if     exist %PG%.rc      echo windres -F %TARGET% -O coff -o temp.o %PG%.rc
if     exist %PG%.rc %GCC%\bin\windres -F %TARGET% -O coff -o temp.o %PG%.rc
if not exist %PG%.rc call %TOOLS%\AddVer.bat
if not exist %PG%.rc      echo windres -F %TARGET% -O coff -o temp.o temp.rc
if not exist %PG%.rc %GCC%\bin\windres -F %TARGET% -O coff -o temp.o temp.rc
if ERRORLEVEL 1 goto SkipCompile

if exist %EXE%.exe del %EXE%.exe
     echo %CC% -Wall -I. -m%BIT% -o %EXE%.exe %OP% %PG2% %SUBSRCS% %LINKOPT% temp.o -lgdi32 -lcomdlg32 -lwinmm -ladvapi32 -limm32 -lwininet -lcomctl32 -liphlpapi %LIBSGC% -static -lstdc++ -lgcc %OMPLIB%
%GCC%\bin\%CC% -Wall -I. -m%BIT% -o %EXE%.exe %OP% %PG2% %SUBSRCS% %LINKOPT% temp.o -lgdi32 -lcomdlg32 -lwinmm -ladvapi32 -limm32 -lwininet -lcomctl32 -liphlpapi %LIBSGC% -static -lstdc++ -lgcc %OMPLIB%

:SkipCompile
if ERRORLEVEL 1 set HIT=1

IF EXIST %PG%.x del %PG%.x
IF EXIST *.o del *.o
IF EXIST temp.rc del temp.rc
:EndOfBat
echo/
if '%HIT%' == '1' pause
