/*
zmtrand.c ver 2.09 Cu{
coded by isaku@pb4.so-net.ne.jp
*/

#include "zmtrand.h"

/*+--------------------------------+
@|}NœnftHg̗̈|
@+--------------------------------+*/
#if defined(OLD_MSEQ)
struct _state_t DefaultMt[MSEQ];
#else
struct _state_t DefaultMt[1];
 #if MSEQ > 0
struct _state_t DefaultMseq[MSEQ];
 #endif
#endif

/*+--------------------------------------------+
@|InitMt_r()Ă΂ȂƂ̃ftHg̎|
@+--------------------------------------------+*/
#if MSEQ > MAX_MSEQ
static volatile long DefaultSeed=MSEQ;
#else
static volatile long DefaultSeed=MAX_MSEQ;
#endif

#if defined(_MSC_VER) && INT_MAX > 32767
 #pragma auto_inline(off)
#endif

#if !defined(ORIGINAL) && !defined(STABLE_SPEED) && defined(HAVE_SIMD)
/*+--------------------------------+
  |SSEeNmWT|[g̃`FbN |
  |SSE2Ȃ  0                   |
  |SSE2  1                   |
  |SSE3  2                   |
  |AVX2  3                   |
  +--------------------------------+*/
 #if defined(_MSC_VER)

  #if _MSC_FULL_VER >= VC2008SP1
int CpuType(void) {
    int reg[4];
    __cpuidex(reg, 7, 0);
    if (reg[1] & 32) return 3;
    __cpuid(reg,1);
    if (reg[2]&1) return 2;
    if (reg[3]&0x04000000) return 1;
    return 0;
}
  #elif _MSC_VER >= VC2005
/* VC2005 ł AVX2 ̔͂Ȃ */
int CpuType(void) {
    int reg[4];
    __cpuid(reg,1);
    if (reg[2]&1) return 2;
    if (reg[3]&0x04000000) return 1;
    return 0;
}
  #else
/* VC2003 ȑOł AVX2 ̔͂Ȃ */
int CpuType(void) {
    _asm {
        push    ebx
        push    ecx
        push    edx
        pushfd
        pop     eax
        xor     eax, 00200000h
        push    eax
        popfd
        pushfd
        pop     edx
        cmp     eax, edx
        jnz     no_sse2
        mov     eax, 1
        cpuid
        and     ecx, 1
        jnz     yes_sse3
        and     edx, 04000000h
        jnz     yes_sse2
    no_sse2:
        xor     eax,eax
        jmp     exit_sse
    yes_sse2:
        mov     eax,1
        jmp     exit_sse
    yes_sse3:
        mov     eax,2
    exit_sse:
        pop     edx
        pop     ecx
        pop     ebx
    }
}
  #endif /* _MSC_VER */
 #elif defined(__GNUC__)
/* https://gitea.eponym.info/ZoneMinder/zoneminder/commit/
   2773737e54cf270926cf42aac2c9dacea975f1ad?style=split&
   whitespace=ignore-all */
int CpuType(void) {
   int r_ebx, r_ecx, r_edx;
  #if SYSTEM64
    __asm__ __volatile__(
        "push %%rbx\n\t"
        "mov $0x0,%%ecx\n\t"
        "mov $0x7,%%eax\n\t"
        "cpuid\n\t"
        "push %%rbx\n\t"
        "mov $0x1,%%eax\n\t"
        "cpuid\n\t"
        "pop %%rax\n\t"
        "pop %%rbx\n\t"
      : "=d" (r_edx), "=c" (r_ecx), "=a" (r_ebx) : :);
  #else
    __asm__ __volatile__(
        "push %%ebx\n\t"
        "mov $0x0,%%ecx\n\t"
        "mov $0x7,%%eax\n\t"
        "cpuid\n\t"
        "push %%ebx\n\t"
        "mov $0x1,%%eax\n\t"
        "cpuid\n\t"
        "pop %%eax\n\t"
        "pop %%ebx\n\t"
        : "=d" (r_edx), "=c" (r_ecx), "=a" (r_ebx) : : );
  #endif
    if (r_ebx&32) return 3;
    if (r_ecx&1) return 2;
    if (r_edx&0x04000000) return 1;
    return 0;
}
 #else /* ! _MSC_VER && ! __GNUC__ */
  #if defined(HAVE_AVX2)
   int CpuType(void) { return 3; }
  #elif defined(HAVE_SSE3)
   int CpuType(void) { return 2; }
  #elif defined(HAVE_SSE2)
   int CpuType(void) { return 1; }
  #endif
 #endif
#endif /* !ORIGINAL && !STABLE_SPEED && HAVE_SIMD */

/* FECH_INC ̃}VvO */
#if ( defined(_MSC_VER) && _MSC_VER >= VC2005 )
#elif defined(__GNUC__)
#elif defined(_M_IX86)||defined(__i386)||defined(_M_X64)||defined(__x86_64__)
/*
 #if defined(__GNUC__)
  #define ALLOC_TEXT__(X) const char X[]__attribute__((section(".text#")))
 #elif defined(_MSC_VER)
*/
 #if defined(_MSC_VER)
  #pragma code_seg(".text")
  #define ALLOC_TEXT__(X) __declspec(allocate(".text"))const char X[]
 #elif defined(__BORLANDC__)
  #define ALLOC_TEXT__(X) extern const char X[]
 #else
  #define ALLOC_TEXT__(X) const char X[]
 #endif
ALLOC_TEXT__(F_INC_)=
    "\xB8\x01\x00\x00\x00" /* mov eax,1   */
    "\x0F\xC1\x01"         /* lock xadd dword ptr[ecx],eax */
    "\xC3";                /* ret */
#endif

#if !defined(ORIGINAL) && !defined(STABLE_SPEED)
 #if defined(HAVE_AVX2)
static simd_t Msk1={{UPPER_MASK,UPPER_MASK,UPPER_MASK,UPPER_MASK,
                     UPPER_MASK,UPPER_MASK,UPPER_MASK,UPPER_MASK}};
static simd_t Msk2={{LOWER_MASK,LOWER_MASK,LOWER_MASK,LOWER_MASK,
                     LOWER_MASK,LOWER_MASK,LOWER_MASK,LOWER_MASK}};
static simd_t Mag={{MATRIX_A,MATRIX_A,MATRIX_A,MATRIX_A,
                    MATRIX_A,MATRIX_A,MATRIX_A,MATRIX_A}};
  #if defined(COMPACT) || defined(EXTEND)
   #if !defined(COMPACT)
static simd_t
   #else
simd_t
   #endif
MskB={{MASK_B,MASK_B,MASK_B,MASK_B,MASK_B,MASK_B,MASK_B,MASK_B}},
MskC={{MASK_C,MASK_C,MASK_C,MASK_C,MASK_C,MASK_C,MASK_C,MASK_C}};
  #endif
 #elif defined(HAVE_SSE2) || defined(HAVE_SSE3)
static simd_t Msk1={{UPPER_MASK,UPPER_MASK,UPPER_MASK,UPPER_MASK}};
static simd_t Msk2={{LOWER_MASK,LOWER_MASK,LOWER_MASK,LOWER_MASK}};
static simd_t Mag={{MATRIX_A,MATRIX_A,MATRIX_A,MATRIX_A}};
  #if defined(COMPACT) || defined(EXTEND)
   #if !defined(COMPACT)
static simd_t
   #else
simd_t
   #endif
MskB={{MASK_B,MASK_B,MASK_B,MASK_B}},MskC={{MASK_C,MASK_C,MASK_C,MASK_C}};
  #endif
 #endif
#endif

/*+------------+
@|̈|
@+------------+*/
#if defined(__GNUC__)
__attribute__((noinline))
#endif
void InitMt_r(state_p arg,uint32_t s) {
    unsigned p;
#if defined(ORIGINAL) || defined(STABLE_SPEED)
    arg->flag=0;
#elif defined(HAVE_AVX2)
    arg->flag=CpuType()>=3;
#elif defined(HAVE_SSE3)
    arg->flag=CpuType()>=2;
#elif defined(HAVE_SSE2)
    arg->flag=CpuType()>=1;
#else
    arg->flag=0;
#endif
#if defined(ORIGINAL) && !defined(STABLE_SPEED)
    arg->index=MT_N;
#else
    arg->index=MT_N*MT_S;
#endif
    arg->range=0; arg->normal_sw=0;
    arg->coin_bits=0; arg->byte_pos=0;
    for (arg->u.x[0]=s,p=1;p<MT_N;p++)
        arg->u.x[p]=s=1812433253U*(s^(s>>30))+p;
}

#if defined(__GNUC__)
__attribute__((noinline))
#endif
void InitDefault_r(state_p arg) {
#if defined(ORIGINAL) && !defined(STABLE_SPEED) && 0
    if (arg==DefaultMt) InitMt_r(arg,5489);
#else
    if (arg==DefaultMt) InitMt_r(arg,1);
#endif
#if MSEQ > 0
    else if (arg>=DefaultMseq&&arg<&DefaultMseq[MSEQ])
         InitMt_r(arg,(uint32_t)(DefaultMseq-arg));
#endif
    else InitMt_r(arg,(uint32_t)-FETCH_INC(&DefaultSeed));
}

/*+------------------+
@|zgď|
@+------------------+*/
#if defined(__GNUC__)
__attribute__((noinline))
#endif
void InitMtEx_r(state_p arg,const uint32_t*key,unsigned len) {
    unsigned i=1,j=0,k; uint32_t*x=arg->u.x;
    InitMt_r(arg,19650218U);
    for (k=MT_N>len?MT_N:len;k;k--) {
        x[i]=(x[i]^((x[i-1]^(x[i-1]>>30))*1664525U))+key[j]+j;
        if (++i>=MT_N) { x[0]=x[MT_N-1]; i=1; }
        if (++j>=len) j=0;
    }
    for (k=MT_N-1;k;k--) {
        x[i]=(x[i]^((x[i-1]^(x[i-1]>>30))*1566083941U))-i;
        if (++i>=MT_N) { x[0]=x[MT_N-1]; i=1; }
    }
    x[0]=0x80000000U;
}

#if defined(MAG) && defined(STABLE_SPEED)
 #if INT_MAX <= 32767
const unsigned magLO[2]={0,MATRIX_LO};
const unsigned magHI[2]={0,MATRIX_HI};
 #else
const uint32_t mag01[2]={0,MATRIX_A};
 #endif
#endif

#if defined(ORIGINAL) && !defined(STABLE_SPEED)

 #if defined(__GNUC__)
  __attribute__((noinline))
 #endif
void GenOriginal_r(state_p arg) {
 #if defined(MAG)
    static uint32_t mag01[2]={0x0, MATRIX_A};
 #endif
    int kk; uint32_t*const mt=arg->u.x,y;
    for (kk=0;kk<MT_N-MT_M;kk++) {
        y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
        mt[kk] = mt[kk+MT_M] ^ (y >> 1) ^ EXPR();
    }
    for (;kk<MT_N-1;kk++) {
        y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
        mt[kk] = mt[kk+(MT_M-MT_N)] ^ (y >> 1) ^ EXPR();
    }
    y = (mt[MT_N - 1] & UPPER_MASK) | (mt[0] & LOWER_MASK);
    mt[MT_N-1] = mt[MT_M-1] ^ (y >> 1) ^ EXPR();
}
#elif !defined(STABLE_SPEED)
/*+--------------------+
@|{֐̉֐|
@+--------------------+*/
 #if INT_MAX <= 32767

  #define LOAD_MT(P,U) (\
hi=(*(unsigned*)(P+HI_P+U)&(unsigned)(UPPER_MASK>>16))|\
(*(unsigned*)(P+HI_P+MT_S+U)&(unsigned)(LOWER_MASK>>16)),\
lo=(*(unsigned*)(P+LO_P+U)&(unsigned)UPPER_MASK)|\
(*(unsigned*)(P+LO_P+MT_S+U)&(unsigned)LOWER_MASK))

  #define SAVE_MT(P,U,M) (\
*(unsigned*)(P+HI_P+U)=*(unsigned*)(P+HI_P+(M)*MT_S+U)^(hi>>1)^EXPR(HI),\
*(unsigned*)(P+LO_P+U)=\
  *(unsigned*)(P+LO_P+(M)*MT_S+U)^(lo>>1)^(hi<<15)^EXPR(LO))

/* LOAD_MT  SAVE_MT ɕɂ܂Ƃ߂ĂǂȀꍇA
   LSI-C ŃRpC̃sĂ܂B*/

  #if defined(EXTEND)
   #define TMP_1(P,I) (\
hi=*(unsigned*)(P+HI_P+I),lo=*(unsigned*)(P+LO_P+I),\
j=(hi<<(16-SHIFT_0))|(lo>>SHIFT_0), hi^=hi>>SHIFT_0,lo^=j,\
j=(hi<<SHIFT_B)|(lo>>(16-SHIFT_B)),\
hi^=j&(unsigned)(MASK_B>>16),lo^=(lo<<SHIFT_B)&(unsigned)MASK_B,\
j=(hi<<SHIFT_C)|(lo>>(16-SHIFT_C)),\
hi^=j&(unsigned)(MASK_C>>16),lo^=(lo<<SHIFT_C)&(unsigned)MASK_C,\
lo^=hi>>(SHIFT_1-16),\
*(unsigned*)(P+HI_P+MT_N*4+I)=hi,*(unsigned*)(P+LO_P+MT_N*4+I)=lo)
  #endif

 #else

  #if !defined(HAVE_SIMD) || defined(DUAL)

   #define LOAD_MT(P,U) y=(P[U]&UPPER_MASK)|(P[1+U]&LOWER_MASK)
   #define SAVE_MT(P,U,M) P[U]=y=P[(M)*MT_S+U]^(y>>1)^EXPR()

   #if defined(EXTEND)
    #if SYSTEM64
     #define TWO_BIT64 ((uint64_t)0x100000001)
     #define SHIFT_MASK64(S) ((TWO_BIT64<<(32-(S)))-TWO_BIT64)
     #define TMP_2(P,I) (    \
      w=*(uint64_t*)(P+I),w^=(w>>SHIFT_0)&SHIFT_MASK64(SHIFT_0),\
      w^=(w<<SHIFT_B)&(MASK_B|(((uint64_t)MASK_B)<<32)),\
      w^=(w<<SHIFT_C)&(MASK_C|(((uint64_t)MASK_C)<<32)),\
      w^=(w>>SHIFT_1)&SHIFT_MASK64(SHIFT_1),\
      *(uint64_t*)(P+MT_N*MT_S+I)=w)
    #else
     #define TMP_1(P,I) (    \
      y=*(uint32_t*)(P+I),y^=y>>SHIFT_0,\
      y^=(y<<SHIFT_B)&MASK_B,\
      y^=(y<<SHIFT_C)&MASK_C,\
      y^=y>>SHIFT_1,         \
      *(uint32_t*)(P+MT_N*MT_S+I)=y)
    #endif
   #endif
  #endif
 #endif


 #if INT_MAX <= 32767 || !defined(HAVE_SIMD) || defined(DUAL)
  #if INT_MAX <= 32767 && defined(EXTEND)
   #if defined(LSI_C)
void TEMPER_LSI_C(addr_t*p) {
    unsigned hi,lo,j; addr_t*z=&p[MT_N*MT_S];
    #if defined(SIMPLE16TMP)
    for (;p<z;p+=MT_S) TMP_1(p,0);
    #else
    for (;p<z;p+=8*MT_S) {
        TMP_1(p,0);      TMP_1(p,MT_S);   TMP_1(p,2*MT_S);
        TMP_1(p,3*MT_S); TMP_1(p,4*MT_S); TMP_1(p,5*MT_S);
        TMP_1(p,6*MT_S); TMP_1(p,7*MT_S);
    }
    #endif
}
   #endif
  #endif

  #if defined(__GNUC__)
   __attribute__((noinline))
  #endif
void GenNormal_r(state_p arg) {
  #if ( INT_MAX <= 32767 && defined(SIMPLE16GEN) ) || \
      ( INT_MAX >  32767 && defined(SIMPLE32GEN) )
  #else
    addr_t*p,*z;
  #endif
    {
  #if INT_MAX <= 32767
    unsigned lo,hi;
  #else
    uint32_t y;
  #endif
  #if defined(MAG)
   #if INT_MAX <= 32767
    static const unsigned magLO[2]={0,MATRIX_LO};
    static const unsigned magHI[2]={0,MATRIX_HI};
   #else
    static const uint32_t mag01[2]={0,MATRIX_A};
   #endif
  #endif
  #if ( INT_MAX <= 32767 && defined(SIMPLE16GEN) ) || \
      ( INT_MAX >  32767 && defined(SIMPLE32GEN) )
   #if defined(LSI_C)
    addr_t*p=arg->u.s,*z=&p[(MT_N-MT_M)*MT_S];
    for (;p<z;p+=MT_S)
    { LOAD_MT(p,0); SAVE_MT(p,0,MT_M); }
    for (arg->u.x[MT_N]=arg->u.x[0],z=&arg->u.s[MT_N*MT_S];p<z;p+=MT_S)
    { LOAD_MT(p,0); SAVE_MT(p,0,MT_K); }
   #else
    int i;
    for (i=0;i<(MT_N-MT_M)*MT_S;i+=MT_S)
    { LOAD_MT(arg->u.s,i); SAVE_MT(arg->u.s,i,MT_M); }
    for (arg->u.x[MT_N]=arg->u.x[0];i<MT_N*MT_S;i+=MT_S)
    { LOAD_MT(arg->u.s,i); SAVE_MT(arg->u.s,i,MT_K); }
   #endif
  #else
    p=arg->u.s;
   #if MT_L
    for (z=&p[(MT_N-MT_M-MT_V)*MT_S];;p+=MT_U*MT_S) {
   #else
    for (z=&p[(MT_N-MT_M)*MT_S];p<z;p+=MT_U*MT_S) {
        LOAD_MT(p,0); SAVE_MT(p,0,MT_M);
   #endif
   #if MT_U > 1
        LOAD_MT(p,(1-MT_L)*MT_S); SAVE_MT(p,(1-MT_L)*MT_S,MT_M);
   #endif
   #if MT_U > 2
        LOAD_MT(p,(2-MT_L)*MT_S); SAVE_MT(p,(2-MT_L)*MT_S,MT_M);
   #endif
   #if MT_U > 3
        LOAD_MT(p,(3-MT_L)*MT_S); SAVE_MT(p,(3-MT_L)*MT_S,MT_M);
   #endif
   #if MT_U > 4
        LOAD_MT(p,(4-MT_L)*MT_S); SAVE_MT(p,(4-MT_L)*MT_S,MT_M);
   #endif
   #if MT_U > 5
        LOAD_MT(p,(5-MT_L)*MT_S); SAVE_MT(p,(5-MT_L)*MT_S,MT_M);
   #endif
   #if MT_U > 6
        LOAD_MT(p,(6-MT_L)*MT_S); SAVE_MT(p,(6-MT_L)*MT_S,MT_M);
   #endif
   #if MT_U > 7
        LOAD_MT(p,(7-MT_L)*MT_S); SAVE_MT(p,(7-MT_L)*MT_S,MT_M);
   #endif
   #if MT_U > 8
        LOAD_MT(p,(8-MT_L)*MT_S); SAVE_MT(p,(8-MT_L)*MT_S,MT_M);
   #endif
   #if MT_U > 9
        LOAD_MT(p,(9-MT_L)*MT_S); SAVE_MT(p,(9-MT_L)*MT_S,MT_M);
   #endif
   #if MT_U > 10
        LOAD_MT(p,(10-MT_L)*MT_S); SAVE_MT(p,(10-MT_L)*MT_S,MT_M);
   #endif
   #if MT_U > 11
        LOAD_MT(p,(11-MT_L)*MT_S); SAVE_MT(p,(11-MT_L)*MT_S,MT_M);
   #endif
   #if MT_L
        if (p>=z) break;
        LOAD_MT(p,(MT_U-1)*MT_S); SAVE_MT(p,(MT_U-1)*MT_S,MT_M);
   #endif
    }
   #if MT_L
    p+=MT_U*MT_S; LOAD_MT(p,-1*MT_S); SAVE_MT(p,-1*MT_S,MT_K);
   #endif
    arg->u.x[MT_N]=arg->u.x[0];
    for (z=(addr_t*)&arg->u.x[MT_N];p<z;p+=MT_U*MT_S) {
        LOAD_MT(p,0); SAVE_MT(p,0,MT_K);
   #if MT_U > 1
        LOAD_MT(p,MT_S); SAVE_MT(p,MT_S,MT_K);
   #endif
   #if MT_U > 2
        LOAD_MT(p,2*MT_S); SAVE_MT(p,2*MT_S,MT_K);
   #endif
   #if MT_U > 3
        LOAD_MT(p,3*MT_S); SAVE_MT(p,3*MT_S,MT_K);
   #endif
   #if MT_U > 4
        LOAD_MT(p,4*MT_S); SAVE_MT(p,4*MT_S,MT_K);
   #endif
   #if MT_U > 5
        LOAD_MT(p,5*MT_S); SAVE_MT(p,5*MT_S,MT_K);
   #endif
   #if MT_U > 6
        LOAD_MT(p,6*MT_S); SAVE_MT(p,6*MT_S,MT_K);
   #endif
   #if MT_U > 7
        LOAD_MT(p,7*MT_S); SAVE_MT(p,7*MT_S,MT_K);
   #endif
   #if MT_U > 8
        LOAD_MT(p,8*MT_S); SAVE_MT(p,8*MT_S,MT_K);
   #endif
   #if MT_U > 9
        LOAD_MT(p,9*MT_S); SAVE_MT(p,9*MT_S,MT_K);
   #endif
   #if MT_U > 10
        LOAD_MT(p,10*MT_S); SAVE_MT(p,10*MT_S,MT_K);
   #endif
   #if MT_U > 11
        LOAD_MT(p,11*MT_S); SAVE_MT(p,11*MT_S,MT_K);
   #endif
    }
  #endif
    }
  #if defined(EXTEND)
    {
   #if defined(LSI_C)
    TEMPER_LSI_C(arg->u.s);
   #else
    #if INT_MAX <= 32767
    unsigned j,hi,lo;
    #elif SYSTEM64
    uint64_t w;
    #else
    uint32_t y;
    #endif
    #if ( INT_MAX <= 32767 && defined(SIMPLE16TMP) ) || \
        ( INT_MAX >  32767 && defined(SIMPLE32TMP) )
     #if ( INT_MAX <= 32767 && defined(SIMPLE16GEN) ) || \
         ( INT_MAX >  32767 && defined(SIMPLE32GEN) )
    int i;
      #if SYSTEM64
    for (i=0;i<MT_N*MT_S/2;i+=2*MT_S) TMP_2(arg->u.s,i);
      #else
    for (i=0;i<MT_N*MT_S;i+=MT_S) TMP_1(arg->u.s,i);
      #endif
     #else
      #if SYSTEM64
    for (p=arg->u.s;p<z;p+=2*MT_S) TMP_2(p,0);
      #else
    for (p=arg->u.s;p<z;p+=MT_S) TMP_1(p,0);
      #endif
     #endif
    #else
     #if ( INT_MAX <= 32767 && defined(SIMPLE16GEN) ) || \
         ( INT_MAX >  32767 && defined(SIMPLE32GEN) )
    int i;
      #if SYSTEM64
    for (i=0;i<MT_N*MT_S;i+=8*MT_S) {
        TMP_2(arg->u.s,i);   TMP_2(arg->u.s,2*MT_S+i);
        TMP_2(arg->u.s,4*MT_S+i); TMP_2(arg->u.s,6*MT_S+i);
    }
      #else
    for (i=0;i<MT_N*MT_S;i+=8*MT_S) {
        TMP_1(arg->u.s,i);        TMP_1(arg->u.s,MT_S+i);
        TMP_1(arg->u.s,2*MT_S+i); TMP_1(arg->u.s,3*MT_S+i);
        TMP_1(arg->u.s,4*MT_S+i); TMP_1(arg->u.s,5*MT_S+i);
        TMP_1(arg->u.s,6*MT_S+i); TMP_1(arg->u.s,7*MT_S+i);
    }
      #endif
     #else
      #if SYSTEM64
    for (p=arg->u.s;p<z;p+=8*MT_S)
    { TMP_2(p,0); TMP_2(p,2*MT_S); TMP_2(p,4*MT_S); TMP_2(p,6*MT_S); }
      #else
    for (p=arg->u.s;p<z;p+=8*MT_S) {
        TMP_1(p,0);      TMP_1(p,MT_S);   TMP_1(p,2*MT_S);
        TMP_1(p,3*MT_S); TMP_1(p,4*MT_S); TMP_1(p,5*MT_S);
        TMP_1(p,6*MT_S); TMP_1(p,7*MT_S);
    }
      #endif
     #endif
    #endif
   #endif
    }
  #endif
}
 #endif
 #if defined(LOAD_MT)
  #undef LOAD_MT
 #endif
 #if defined(SAVE_MT)
  #undef SAVE_MT
 #endif
 #if defined(TMP_1)
  #undef TMP_1
 #endif
 #if defined(TMP_2)
  #undef TMP_2
 #endif

 #if defined(HAVE_SIMD)

  #if defined(HAVE_AVX2)
   #define TMP_A(i) do {                                 \
    u=_mm256_load_si256((__m256i*)(arg->u.x+(i)));       \
    v=_mm256_srli_epi32(u,SHIFT_0);                      \
    u=_mm256_xor_si256(u,v);                             \
    v=_mm256_slli_epi32(u,SHIFT_B);                      \
    v=_mm256_and_si256(v,mskB);                          \
    u=_mm256_xor_si256(u,v);                             \
    v=_mm256_slli_epi32(u,SHIFT_C);                      \
    v=_mm256_and_si256(v,mskC);                          \
    u=_mm256_xor_si256(u,v);                             \
    v=_mm256_srli_epi32(u,SHIFT_1);                      \
    u=_mm256_xor_si256(u,v);                             \
    _mm256_store_si256((__m256i*)(arg->u.x+MT_N+(i)),u); \
    } while (0)
   #if defined(SIMPLE256TMP)
    #define TEMPER_AVX2() do {        \
     __m256i u,v,mskB,mskC; size_t i; \
     mskB=_mm256_load_si256(&MskB.a); \
     mskC=_mm256_load_si256(&MskC.a); \
     for (i=0;i<MT_N;i+=8) TMP_A(i);  \
     } while (0)
   #elif MEXP == 1279
    #define TEMPER_AVX2() do {        \
     __m256i u,v,mskB,mskC;           \
     mskB=_mm256_load_si256(&MskB.a); \
     mskC=_mm256_load_si256(&MskC.a); \
     TMP_A(0);  TMP_A(8);  TMP_A(16); \
     TMP_A(24); TMP_A(32);            \
     } while (0)
   #elif MEXP == 2281
    #define TEMPER_AVX2() do {        \
     __m256i u,v,mskB,mskC;           \
     mskB=_mm256_load_si256(&MskB.a); \
     mskC=_mm256_load_si256(&MskC.a); \
     TMP_A(0);  TMP_A(8);  TMP_A(16); \
     TMP_A(24); TMP_A(32); TMP_A(40); \
     TMP_A(48); TMP_A(56); TMP_A(64); \
     } while (0)
   #elif MEXP == 19937
    #define TEMPER_AVX2() do {                                \
     __m256i u,v,mskB,mskC;  size_t i=0;                      \
     mskB=_mm256_load_si256(&MskB.a);                         \
     mskC=_mm256_load_si256(&MskC.a);                         \
     TMP_A(0); i+=8;                                          \
     do { TMP_A(i);    TMP_A(8+i);  TMP_A(16+i); TMP_A(24+i); \
          TMP_A(32+i); TMP_A(40+i); TMP_A(48+i); i+=56;       \
     } while (i<MT_N);                                        \
     } while (0)
   #endif
  #else /* HAVE_AVX2 -> HAVE_SSE2 */
   #define TMP_S(I) do {                              \
    u=_mm_load_si128((__m128i*)(arg->u.x+I));         \
    v=_mm_srli_epi32(u,SHIFT_0);                      \
    u=_mm_xor_si128(u,v);                             \
    v=_mm_slli_epi32(u,SHIFT_B);                      \
    v=_mm_and_si128(v,mskB);                          \
    u=_mm_xor_si128(u,v);                             \
    v=_mm_slli_epi32(u,SHIFT_C);                      \
    v=_mm_and_si128(v,mskC);                          \
    u=_mm_xor_si128(u,v);                             \
    v=_mm_srli_epi32(u,SHIFT_1);                      \
    u=_mm_xor_si128(u,v);                             \
    _mm_store_si128((__m128i*)(arg->u.x+MT_N+I),u);   \
    u=_mm_load_si128((__m128i*)(arg->u.x+4+I));       \
    v=_mm_srli_epi32(u,SHIFT_0);                      \
    u=_mm_xor_si128(u,v);                             \
    v=_mm_slli_epi32(u,SHIFT_B);                      \
    v=_mm_and_si128(v,mskB);                          \
    u=_mm_xor_si128(u,v);                             \
    v=_mm_slli_epi32(u,SHIFT_C);                      \
    v=_mm_and_si128(v,mskC);                          \
    u=_mm_xor_si128(u,v);                             \
    v=_mm_srli_epi32(u,SHIFT_1);                      \
    u=_mm_xor_si128(u,v);                             \
    _mm_store_si128((__m128i*)(arg->u.x+MT_N+4+I),u); \
    } while (0)

   #if defined(SIMPLE128TMP)
    #define TEMPER_SSE() do {         \
     __m128i u,v,mskB,mskC; size_t i; \
     mskB=_mm_load_si128(&MskB.m);    \
     mskC=_mm_load_si128(&MskC.m);    \
     for (i=0;i<MT_N;i+=8) TMP_S(i);  \
   } while (0)
   #elif MEXP == 1279
    #define TEMPER_SSE() do {        \
     __m128i u,v,mskB,mskC;          \
     mskB=_mm_load_si128(&MskB.m);   \
     mskC=_mm_load_si128(&MskC.m);   \
     TMP_S(0);  TMP_S(8); TMP_S(16); \
     TMP_S(24); TMP_S(32);           \
     } while (0)
   #elif MEXP == 2281
    #define TEMPER_SSE() do {         \
     __m128i u,v,mskB,mskC;           \
     mskB=_mm_load_si128(&MskB.m);    \
     mskC=_mm_load_si128(&MskC.m);    \
     TMP_S(0);  TMP_S(8);  TMP_S(16); \
     TMP_S(24); TMP_S(32); TMP_S(40); \
     TMP_S(48); TMP_S(56); TMP_S(64); \
     } while (0)
   #elif MEXP == 19937
    #define TEMPER_SSE() do {                                 \
     __m128i u,v,mskB,mskC; size_t i=0;                       \
     mskB=_mm_load_si128(&MskB.m);                            \
     mskC=_mm_load_si128(&MskC.m);                            \
     TMP_S(i); i+=8;                                          \
     do { TMP_S(i);    TMP_S(8+i);  TMP_S(16+i); TMP_S(24+i); \
          TMP_S(32+i); TMP_S(40+i); TMP_S(48+i); i+=56;       \
     } while (i<MT_N); } while (0)
   #endif
  #endif

  #if defined(HAVE_AVX2)
   #define REC_A(X,I) do {                            \
    u=_mm256_load_si256((__m256i*)(arg->u.x+I));      \
    u=_mm256_and_si256(u,msk1);                       \
    v=_mm256_loadu_si256((__m256i*)(arg->u.x+1+I));   \
    v=_mm256_and_si256(v,msk2);                       \
    v=u=_mm256_or_si256(u,v);                         \
    v=_mm256_slli_epi32(v,31);                        \
    v=_mm256_srai_epi32(v,31);                        \
    v=_mm256_and_si256(v,mag);                        \
    u=_mm256_srli_epi32(u,1);                         \
    u=_mm256_xor_si256(u,v);                          \
    v=_mm256_loadu_si256((__m256i*)(arg->u.x+(X)+I)); \
    u=_mm256_xor_si256(u,v);                          \
    _mm256_store_si256((__m256i*)(arg->u.x+I),u);     \
    } while (0)

   #if defined(SIMPLE256GEN) && MEXP != 19937
    #define GEN_ALL_AVX2() do {                             \
    __m256i mag,msk1,msk2,u,v; size_t i;                    \
    mag =_mm256_load_si256(&Mag.a);                         \
    msk1=_mm256_load_si256(&Msk1.a);                        \
    msk2=_mm256_load_si256(&Msk2.a);                        \
    for (i=0;i<MT_N-MT_M-4;i+=8) REC_A(MT_M,i);             \
    *(__m128i*)&arg->u.x[MT_N]=*(__m128i*)&arg->u.x[0];     \
    REC_A(MT_M,i);                                          \
    for (i=MT_N-MT_M+4;i<MT_N;i+=8) REC_A(MT_K,i);          \
    } while (0)
   #elif defined(SIMPLE256GEN)
    #define GEN_ALL_AVX2() do {                         \
    __m256i mag,msk1,msk2,u,v; size_t i;                \
    mag =_mm256_load_si256(&Mag.a);                     \
    msk1=_mm256_load_si256(&Msk1.a);                    \
    msk2=_mm256_load_si256(&Msk2.a);                    \
    for (i=0;i<MT_N-MT_M-3;i+=8) REC_A(MT_M,i);         \
    *(__m256i*)&arg->u.x[MT_N]=*(__m256i*)&arg->u.x[0]; \
    REC_A(MT_M,i); /*i+=8;*/                            \
    for (i=MT_N-MT_M+5;i<MT_N;i+=8) REC_A(MT_K,i);      \
    } while (0)
   #elif MEXP == 1279
    #define GEN_ALL_AVX2() do {                         \
    __m256i mag,msk1,msk2,u,v;                          \
    mag =_mm256_load_si256(&Mag.a);                     \
    msk1=_mm256_load_si256(&Msk1.a);                    \
    msk2=_mm256_load_si256(&Msk2.a);                    \
    REC_A(20,0); REC_A(20,8);                           \
    *(__m128i*)&arg->u.x[MT_N]=*(__m128i*)&arg->u.x[0]; \
    REC_A(20,16); REC_A(-20,24); REC_A(-20,32);         \
    } while (0)
   #elif MEXP == 2281
    #define GEN_ALL_AVX2() do {                           \
    __m256i mag,msk1,msk2,u,v;                            \
    mag =_mm256_load_si256(&Mag.a);                       \
    msk1=_mm256_load_si256(&Msk1.a);                      \
    msk2=_mm256_load_si256(&Msk2.a);                      \
    REC_A(36,0); REC_A(36,8); REC_A(36,16); REC_A(36,24); \
    *(__m128i*)&arg->u.x[MT_N]=*(__m128i*)&arg->u.x[0];   \
    REC_A(36,32); REC_A(-36,40); REC_A(-36,48);           \
    REC_A(-36,56); REC_A(-36,64);                         \
    } while (0)
   #elif MEXP == 19937
    #define GEN_ALL_AVX2() do {                            \
    __m256i mag,msk1,msk2,u,v; size_t i=0;                 \
    mag =_mm256_load_si256(&Mag.a);                        \
    msk1=_mm256_load_si256(&Msk1.a);                       \
    msk2=_mm256_load_si256(&Msk2.a);                       \
    do { REC_A(MT_M,i); REC_A(MT_M,8+i); REC_A(MT_M,16+i); \
     REC_A(MT_M,24+i); REC_A(MT_M,32+i); REC_A(MT_M,40+i); \
     REC_A(MT_M,48+i); i+=56; } while (i<MT_N-MT_M-3);     \
    *(__m256i*)&arg->u.x[MT_N]=*(__m256i*)&arg->u.x[0];    \
    REC_A(MT_M,i); i+=8;                                   \
    do { REC_A(MT_K,i); REC_A(MT_K,8+i); REC_A(MT_K,16+i); \
     REC_A(MT_K,24+i); REC_A(MT_K,32+i); REC_A(MT_K,40+i); \
     REC_A(MT_K,48+i); i+=56; } while (i<MT_N);            \
    } while (0)
    #endif
  #elif defined(HAVE_SSE2) || defined(HAVE_SSE3)
   #define RECUR_SSE(X,I,L,K) do {            \
    u=_mm_load_si128((__m128i*)(arg->u.x+I));    \
    u=_mm_and_si128(u,msk1);                \
    v=L((__m128i*)(arg->u.x+1+I));               \
    v=_mm_and_si128(v,msk2);                \
    v=u=_mm_or_si128(u,v);                  \
    v=_mm_slli_epi32(v,31);                 \
    v=_mm_srai_epi32(v,31);                 \
    v=_mm_and_si128(v,mag);                 \
    u=_mm_srli_epi32(u,1);                  \
    u=_mm_xor_si128(u,v);                   \
    v=K((__m128i*)(arg->u.x+(X)+I));        \
    u=_mm_xor_si128(u,v);                   \
    _mm_store_si128((__m128i*)(arg->u.x+I),u);   \
    } while (0)
   #if MEXP == 19937
    #define REC_S(X,I,L) RECUR_SSE(X,I,L,L)
   #else
    #define REC_S(X,I,L) RECUR_SSE(X,I,L,_mm_load_si128)
   #endif
   #if defined(SIMPLE128GEN) && MEXP != 19937
    #define GEN_ALL_SSE(L) do { __m128i mag,msk1,msk2,u,v; \
    size_t i;                                              \
    mag =_mm_load_si128(&Mag.m);                           \
    msk1=_mm_load_si128(&Msk1.m);                          \
    msk2=_mm_load_si128(&Msk2.m);                          \
    for (i=0;i<MT_N-MT_M-4;i+=4) REC_S(MT_M,i,L);          \
    *(__m128i*)&arg->u.x[MT_N]=*(__m128i*)&arg->u.x[0];    \
    REC_S(MT_M,i,L); /*i+=4;*/                             \
    for (i=MT_N-MT_M;i<MT_N;i+=4) REC_S(MT_K,i,L);         \
    } while (0)
   #elif defined(SIMPLE128GEN)
    #define GEN_ALL_SSE(L) do {                           \
   __m128i mag,msk1,msk2,u,v;  size_t i;                  \
    mag =_mm_load_si128(&Mag.m);                          \
    msk1=_mm_load_si128(&Msk1.m);                         \
    msk2=_mm_load_si128(&Msk2.m);                         \
    for (i=0;i<MT_N-MT_M-3;i+=4) REC_S(MT_M,i,L);         \
    arg->u.x[MT_N]=arg->u.x[0]; REC_S(MT_M,i,L);/*i+=4;*/ \
    for (i=MT_N-MT_M+1;i<MT_N;i+=4) REC_S(MT_K,i,L);      \
    } while (0)
   #elif MEXP == 1279
    #define GEN_ALL_SSE(L) do { \
    __m128i mag,msk1,msk2,u,v; \
    mag =_mm_load_si128(&Mag.m);                        \
    msk1=_mm_load_si128(&Msk1.m);                       \
    msk2=_mm_load_si128(&Msk2.m);                       \
    REC_S(20,0,L); REC_S(20,4,L);                       \
    REC_S(20,8,L); REC_S(20,12,L);                      \
    *(__m128i*)&arg->u.x[MT_N]=*(__m128i*)&arg->u.x[0]; \
    REC_S(20,16,L);  REC_S(-20,20,L);                   \
    REC_S(-20,24,L); REC_S(-20,28,L);                   \
    REC_S(-20,32,L); REC_S(-20,36,L);                   \
    } while (0)
   #elif MEXP == 2281
    #define GEN_ALL_SSE(L) do {                         \
    __m128i mag,msk1,msk2,u,v;                          \
    mag =_mm_load_si128(&Mag.m);                        \
    msk1=_mm_load_si128(&Msk1.m);                       \
    msk2=_mm_load_si128(&Msk2.m);                       \
    REC_S(36,0,L);  REC_S(36,4,L);                      \
    REC_S(36,8,L);  REC_S(36,12,L);                     \
    REC_S(36,16,L); REC_S(36,20,L);                     \
    REC_S(36,24,L); REC_S(36,28,L);                     \
    *(__m128i*)&arg->u.x[MT_N]=*(__m128i*)&arg->u.x[0]; \
    REC_S(36,32,L);  REC_S(-36,36,L);                   \
    REC_S(-36,40,L); REC_S(-36,44,L);                   \
    REC_S(-36,48,L); REC_S(-36,52,L);                   \
    REC_S(-36,56,L); REC_S(-36,60,L);                   \
    REC_S(-36,64,L); REC_S(-36,68,L); } while (0)
   #elif MEXP == 19937
    #define GEN_ALL_SSE(L) do { \
    __m128i mag,msk1,msk2,u,v; size_t i=0;                       \
    mag =_mm_load_si128(&Mag.m);                                 \
    msk1=_mm_load_si128(&Msk1.m);                                \
    msk2=_mm_load_si128(&Msk2.m);                                \
    do { REC_S(MT_M,i,L); REC_S(MT_M,4+i,L); REC_S(MT_M,8+i,L);  \
     REC_S(MT_M,12+i,L); REC_S(MT_M,16+i,L); REC_S(MT_M,20+i,L); \
     REC_S(MT_M,24+i,L); REC_S(MT_M,28+i,L); REC_S(MT_M,32+i,L); \
     REC_S(MT_M,36+i,L); REC_S(MT_M,40+i,L); REC_S(MT_M,44+i,L); \
     REC_S(MT_M,48+i,L); REC_S(MT_M,52+i,L); i+=56;              \
    } while (i<MT_N-MT_M-3);                                     \
    arg->u.x[MT_N]=arg->u.x[0];                                  \
    REC_S(MT_M,i,L); REC_S(MT_K,4+i,L); i+=8;                    \
    do { REC_S(MT_K,i,L); REC_S(MT_K,4+i,L); REC_S(MT_K,8+i,L);  \
     REC_S(MT_K,12+i,L); REC_S(MT_K,16+i,L); REC_S(MT_K,20+i,L); \
     REC_S(MT_K,24+i,L); REC_S(MT_K,28+i,L); REC_S(MT_K,32+i,L); \
     REC_S(MT_K,36+i,L); REC_S(MT_K,40+i,L); REC_S(MT_K,44+i,L); \
     REC_S(MT_K,48+i,L); REC_S(MT_K,52+i,L); i+=56;              \
    } while (i<MT_N);                                            \
    } while (0)
   #endif
  #endif

  #if defined(__GNUC__)
   #pragma GCC push_options
  #endif
  #if defined(EXTEND)
   #if defined(HAVE_AVX2)
    #if defined(__GNUC__)
     #pragma GCC target("avx2")
     __attribute__((noinline))
    #endif
void GenSIMD_r(state_p arg) {GEN_ALL_AVX2();TEMPER_AVX2();}
   #elif defined(HAVE_SSE3)
    #if defined(__GNUC__)
     #pragma GCC target("sse3")
     __attribute__((noinline))
    #endif
void GenSIMD_r(state_p arg) {GEN_ALL_SSE(_mm_lddqu_si128);TEMPER_SSE();}
   #elif defined(HAVE_SSE2)
    #if defined(__GNUC__)
     #pragma GCC target("sse2")
     __attribute__((noinline))
    #endif
void GenSIMD_r(state_p arg) {GEN_ALL_SSE(_mm_loadu_si128);TEMPER_SSE();}
   #endif
  #else
   #if defined(HAVE_AVX2)
    #if defined(__GNUC__)
     #pragma GCC target("avx2")
     __attribute__((noinline))
    #endif
void GenSIMD_r(state_p arg) { GEN_ALL_AVX2(); }
   #elif defined(HAVE_SSE3)
    #if defined(__GNUC__)
     #pragma GCC target("sse3")
     __attribute__((noinline))
    #endif
void GenSIMD_r(state_p arg) { GEN_ALL_SSE(_mm_lddqu_si128); }
   #elif defined(HAVE_SSE2)
    #if defined(__GNUC__)
     #pragma GCC target("sse2")
     __attribute__((noinline))
    #endif
void GenSIMD_r(state_p arg) { GEN_ALL_SSE(_mm_loadu_si128); }
   #endif
  #endif
  #if defined(__GNUC__)
   #pragma GCC pop_options
  #endif
 #endif
#endif

/*+--------------+
@|RXgN^|
@+--------------+*/
#if defined(__cplusplus)
_state_t::_state_t() { InitDefault_r(this); }
#endif

#if defined(_MSC_VER) && INT_MAX > 32767
 #pragma auto_inline(on)
#endif

#if defined(NO_INLINE)
 #if defined(_MSC_VER) && INT_MAX > 32767
  #pragma auto_inline(off)
 #endif
 #if defined(__GNUC__)
  #define INLINE_OR_NOT __attribute__((noinline))
 #else
  #define INLINE_OR_NOT
 #endif
 #define NextMt_R(A) NextMt_r(A)
 #include "zmtsub.c"
 #undef NextMt_R
 #if ( INT_MAX <= 32767 || defined(DIRECT) ) && !defined(MACRO)
  #define NextMt_r(A) NextMt(void)
  #define NextUnif_r(A) NextUnif(void)
  #define NextMt64_r(A) NextMt64(void)
  #define NextMt_R(A) NextMt()
  #define arg DefaultMt
  #include "zmtsub.c"
  #undef NextMt_r
  #undef NextUnif_r
  #undef NextMt64_r
  #undef NextMt_R
  #undef arg
 #endif
 #if defined(_MSC_VER) && INT_MAX > 32767
  #pragma auto_inline(on)
 #endif
 #undef INLINE_OR_NOT
#endif

#if !defined(BB_MACRO)

 #if INT_MAX <= 32767
int NextBit_r(state_p arg) {
    if (--arg->coin_bits<0) {
        arg->coin_bits=31;
        return(unsigned char)(arg->c.z=NextMt_r(arg))&1;
    } else if (arg->coin_bits==15)
        return(unsigned char)(arg->c.s.lo=arg->c.s.hi)&1;
    return(unsigned char)(arg->c.s.lo>>=1)&1;
}
 #else
int NextBit_r(state_p arg) {
    if (--arg->coin_bits<0) {
        arg->coin_bits=31;
        return(arg->coin_save=NextMt_r(arg))&1;
    }
    return(arg->coin_save>>=1)&1;
}
 #endif

 #if INT_MAX <= 32767
int NextByte_r(state_p arg) {
    if (--arg->byte_pos<0) {
        arg->byte_pos=3;
        return(unsigned char)(arg->b.z=NextMt_r(arg));
    } else if (arg->byte_pos==2) return arg->b.s.u1;
    else   if (arg->byte_pos==1) return arg->b.s.u2;
    return arg->b.s.u3;
}
 #else
int NextByte_r(state_p arg) {
    if (--arg->byte_pos<0) {
        arg->byte_pos=3;
        return(unsigned char)(arg->byte_save=NextMt_r(arg));
    } else return(unsigned char)(arg->byte_save>>=8);
}
 #endif
#endif

/*+------------------------------------------------------+
@|ۂߌ덷̂ȂOȏrange̐@@@@@@@ |
@|@@@@@@@@@@@@@@@@@@@@@@@@@@@|
@|rangeȂNextInt_r()T{`POB@@@|
@|for (i=0;i<10000;i++)@@@@@@@@@@ @@@@@@|
@|{ x[i]=NextIntEx(100); y[i]=NextIntEx(200); } @@@@|
@|ƂA@@@@@@@@@@@@@@@@@@@@|
@|for (i=0;i<10000;i++) x[i]=NextIntEx(100);@@@@@@|
@|for (i=0;i<10000;i++) y[i]=NextIntEx(200);@@@@@@|
@|ƂقPO{ȏ㍂ɂȂB܂ng|
@|for (i=0;i<10000;i++)@@@@@@@@@@ @@@@@@|
@|{ x[i]=NextIntEx_m(1,100); y[i]=NextIntEx_m(2,200); } |
@|ƂĂPO{ȏ㍂ɂȂ@@@@@@@@@@@@@|
@| range ςȂA@@@@@@@@ |
@|NextInt_r() ɔׂQ{̎Ԃ@@@@@@@@@|
@+------------------------------------------------------+*/
int32_t NextIntEx_r(state_p arg,int32_t range) {
    uint32_t y,base,remain; int shift;
    if (range<=0) return 0;
    if (range!=arg->range) {
        arg->range=base=range;
        for (shift=0;base<=(((uint32_t)1)<<30);shift++) base<<=1;
        arg->base=base; arg->shift=shift;
    }
    for (;;) {
        y=NextMt_r(arg)>>1;
        if (y<arg->base) return(int32_t)(y>>arg->shift);
        base=arg->base; shift=arg->shift; y-=base;
        remain=(((uint32_t)1)<<31)-base;
        for (;remain>=(uint32_t)range;remain-=base) {
            for (;base>remain;base>>=1) shift--;
            if (y<base) return(int32_t)(y>>shift); else y-=base;
        }
    }
}

/*+----------------------------+
@|Rx˂̃JCQ敪z p.27 |
@+----------------------------+*/
double NextChisq_r(state_p arg,double n)
{ return 2*NextGamma_r(arg,0.5*n); }

/*+------------------------------+
@|p[^̃K}z p.31 |
@+------------------------------+*/
double NextGamma_r(state_p arg,double a) {
    double t,u,x,y;
    if (a>1) {
        t=sqrt(2*a-1);
        do {
            do {
                do {
                    do {
                        x=1-NextUnif_r(arg);
                        y=2*NextUnif_r(arg)-1;
                    } while (x*x+y*y>1);
                    y/=x; x=t*y+a-1;
                } while (x<=0);
                u=(a-1)*log(x/(a-1))-t*y;
            } while (u<-50);
        } while (NextUnif_r(arg)>(1+y*y)*exp(u));
    } else {
        t=2.718281828459045235/(a+2.718281828459045235);
        do {
            if (NextUnif_r(arg)<t) {
                x=pow(NextUnif_r(arg),1/a); y=exp(-x);
            } else {
                x=1-log(1-NextUnif_r(arg)); y=pow(x,a-1);
            }
        } while (NextUnif_r(arg)>=y);
    }
    return x;
}

/*+----------------------+
@|mo̊􉽕z p.34 |
@+----------------------+*/
int NextGeometric_r(state_p arg,double p)
{ return(int)ceil(log(1.0-NextUnif_r(arg))/log(1-p)); }

/*+--------------+
@|Opz p.89 |
@+--------------+*/
double NextTriangle_r(state_p arg)
{ const double a=NextUnif_r(arg),b=NextUnif_r(arg); return a-b; }

/*+----------------------+
@|ςP̎wz p.106|
@+----------------------+*/
double NextExp_r(state_p arg)
{ return-log(1-NextUnif_r(arg)); }

/*+----------------------------------+
@|WKz(ő6.660437) p.133|
@+----------------------------------+*/
double NextNormal_r(state_p arg) {
    if (arg->normal_sw==0) {
        const double t=sqrt(-2*log(1.0-NextUnif_r(arg)));
        const double u=3.141592653589793*2*NextUnif_r(arg);
        arg->normal_save=t*sin(u); arg->normal_sw=1; return t*cos(u);
    }else{ arg->normal_sw=0; return arg->normal_save; }
}

/*+----------------------------------+
@|m̃_PʃxNg p.185|
@+----------------------------------+*/
void NextUnitVect_r(state_p arg,double*v,int n) {
    int i; double r=0;
    for (i=0;i<n;i++) { v[i]=NextNormal_r(arg); r+=v[i]*v[i]; }
    if (r==0.0) r=1.0;
    r=sqrt(r);
    for (i=0;i<n;i++) v[i]/=r;
}

/*+--------------------------------+
@|p[^m,ôQz p.203 |
@+--------------------------------+*/
int NextBinomial_r(state_p arg,int n,double p) {
    int i,r=0;
    for (i=0;i<n;i++) if (NextUnif_r(arg)<p) r++;
    return r;
}

/*+--------------------------------+
@|֌Wq̂QϗʐKz p.211|
@+--------------------------------+*/
void NextBinormal_r(state_p arg,double r,double*x,double*y) {
    double r1,r2,s;
    do {
        r1=2*NextUnif_r(arg)-1;
        r2=2*NextUnif_r(arg)-1;
        s=r1*r1+r2*r2;
    } while (s>1||s==0);
    s= -log(s)/s; r1=sqrt((1+r)*s)*r1;
    r2=sqrt((1-r)*s)*r2; *x=r1+r2; *y=r1-r2;
}

/*+----------------------------------+
@|p[^`,ãx[^z p.257 |
@+----------------------------------+*/
double NextBeta_r(state_p arg,double a,double b) {
    const double temp=NextGamma_r(arg,a);
    return temp/(temp+NextGamma_r(arg,b));
}

/*+----------------------------+
@|p[^m̗ݏ敪z p.305|
@+----------------------------+*/
double NextPower_r(state_p arg,double n)
{ return pow(NextUnif_r(arg),1.0/(n+1)); }

/*+------------------------+
@|WXeBbNz p.313|
@+------------------------+*/
double NextLogistic_r(state_p arg) {
    double r;
    do r=NextUnif_r(arg); while (r==0);
    return log(r/(1-r));
}

/*+------------------+
@|R[V[z p.331|
@+------------------+*/
double NextCauchy_r(state_p arg) {
    double x,y;
    do { x=1-NextUnif_r(arg); y=2*NextUnif_r(arg)-1; }
    while (x*x+y*y>1);
    return y/x;
}

/*+--------------------------+
@|Rx`,âez p.344 |
@+--------------------------+*/
double NextFDist_r(state_p arg,double n1,double n2) {
    const double nc1=NextChisq_r(arg,n1),nc2=NextChisq_r(arg,n2);
    return (nc1*n2)/(nc2*n1);
}

/*+--------------------------+
@|σɂ̃|A\z p.412|
@+--------------------------+*/
int NextPoisson_r(state_p arg,double lambda) {
    int k; lambda=exp(lambda)*NextUnif_r(arg);
    for (k=0;lambda>1;k++) lambda*=NextUnif_r(arg);
    return k;
}

/*+----------------------+
@|Rxm̂z p.428|
@+----------------------+*/
double NextTDist_r(state_p arg,double n) {
    double a,b,c;
    if (n<=2) {
        do a=NextChisq_r(arg,n); while (a==0);
        return NextNormal_r(arg)/sqrt(a/n);
    }
    do {
        a=NextNormal_r(arg); b=a*a/(n-2);
        c=log(1-NextUnif_r(arg))/(1-0.5*n);
    } while (exp(-b-c)>1-b);
    return a/sqrt((1-2.0/n)*(1-b));
}

/*+--------------------------------+
@|p[^̃Cuz p.431|
@+--------------------------------+*/
double NextWeibull_r(state_p arg,double alpha)
{ return pow(-log(1-NextUnif_r(arg)),1/alpha); }

