/*
zmtsub.c ver 2.09 CuECN[ht@C
coded by isaku@pb4.so-net.ne.jp
*/
#if defined(STABLE_SPEED) && INT_MAX > 32767
INLINE_OR_NOT uint32_t NextMt_r(state_p arg) {
    uint32_t y;
    NO_CPP_INIT
    if (arg->index==MT_N) arg->index=0;
    {
        const int i=arg->index;
        y=(arg->u.x[i]&UPPER_MASK)|(arg->u.x[i<MT_N-1?i+1:0]&LOWER_MASK);
        y=arg->u.x[i<MT_N-MT_M?i+MT_M:i-MT_N+MT_M]^(y>>1)^EXPR();
        arg->u.x[i]=y; arg->index=i+1; y^=y>>SHIFT_0; y^=(y<<SHIFT_B)&MASK_B;
        y^=(y<<SHIFT_C)&MASK_C; y^=y>>SHIFT_1; return y;
    }
}
#elif defined(STABLE_SPEED) && INT_MAX <= 32767
INLINE_OR_NOT uint32_t NextMt_r(state_p arg) {
    unsigned i,j,lo,hi;
    NO_CPP_INIT
    if (arg->index==MT_N*MT_S) arg->index=0;
    i=arg->index; arg->index+=MT_S; j=i<MT_N*4-MT_S?i+MT_S:0;
    hi=(*(unsigned*)(arg->u.s+HI_P+i)&(unsigned)(UPPER_MASK>>16))|
       (*(unsigned*)(arg->u.s+HI_P+j)&(unsigned)(LOWER_MASK>>16));
    lo=(*(unsigned*)(arg->u.s+LO_P+i)&(unsigned)UPPER_MASK)|
       (*(unsigned*)(arg->u.s+LO_P+j)&(unsigned)LOWER_MASK);
    j=i<(MT_N-MT_M)*MT_S?i+MT_M*MT_S:i-(MT_N-MT_M)*MT_S;
    *(unsigned*)(arg->u.s+HI_P+i)=*(unsigned*)(arg->u.s+HI_P+j)^(hi>>1)^
        EXPR(HI);
    *(unsigned*)(arg->u.s+LO_P+i)=lo=*(unsigned*)(arg->u.s+LO_P+j)^
        (lo>>1)^(hi<<15)^EXPR(LO);
    hi=*(unsigned*)(arg->u.s+HI_P+i);
    j=(hi<<(16-SHIFT_0))|(lo>>SHIFT_0); hi^=hi>>SHIFT_0; lo^=j;
    j=(hi<<SHIFT_B)|(lo>>(16-SHIFT_B));
    hi^=j&(unsigned)(MASK_B>>16); lo^=(lo<<SHIFT_B)&(unsigned)MASK_B;
    j=(hi<<SHIFT_C)|(lo>>(16-SHIFT_C));
    hi^=j&(unsigned)(MASK_C>>16); lo^=(lo<<SHIFT_C)&(unsigned)MASK_C;
    lo^=hi>>(SHIFT_1-16); return((uint32_t)hi<<16)|lo;
}
#elif defined(ORIGINAL)
INLINE_OR_NOT uint32_t NextMt_r(state_p arg) {
    uint32_t*const mt=arg->u.x; uint32_t y;
    NO_CPP_INIT
    if (arg->index==MT_N) { GenOriginal_r(arg); arg->index = 0; }
    y = mt[arg->index++];
    y ^= (y >> SHIFT_0);
    y ^= (y << SHIFT_B) & MASK_B;
    y ^= (y << SHIFT_C) & MASK_C;
    y ^= (y >> SHIFT_1);
    return y;
}
#elif INT_MAX <= 32767
 #if defined(EXTEND)
INLINE_OR_NOT uint32_t NextMt_r(state_p arg) {
     unsigned j;
     NO_CPP_INIT
     if (arg->index==MT_N*MT_S) { GenNormal_r(arg); arg->index=0; }
     j=arg->index; arg->index+=MT_S;
     return*(uint32_t*)(arg->u.s+MT_N*MT_S+j);
}
 #else
INLINE_OR_NOT uint32_t NextMt_r(state_p arg) {
     unsigned lo,hi,j; char*p;
     NO_CPP_INIT
     if (arg->index==MT_N*MT_S) { GenNormal_r(arg); arg->index=0; }
     p=(char*)(arg->u.x)+arg->index; arg->index+=MT_S;
     hi=*(unsigned*)(p+HI_P); lo=*(unsigned*)(p+LO_P);
     j=(hi<<(16-SHIFT_0))|(lo>>SHIFT_0); hi^=hi>>SHIFT_0; lo^=j;
     j=(hi<<SHIFT_B)|(lo>>(16-SHIFT_B));
     hi^=j&(unsigned)(MASK_B>>16); lo^=(lo<<SHIFT_B)&(unsigned)MASK_B;
     j=(hi<<SHIFT_C)|(lo>>(16-SHIFT_C));
     hi^=j&(unsigned)(MASK_C>>16); lo^=(lo<<SHIFT_C)&(unsigned)MASK_C;
     lo^=hi>>(SHIFT_1-16); return((uint32_t)hi<<16)|lo;
}
 #endif
#elif defined(HAVE_SIMD)
 #if !defined(EXTEND)
  #if !defined(COMPACT)
INLINE_OR_NOT uint32_t NextMt_r(state_p arg) {
    uint32_t y;
    NO_CPP_INIT
    if (arg->index==MT_N) {
   #if defined(DUAL)
        if (arg->flag)
   #endif
            GenSIMD_r(arg);
   #if defined(DUAL)
        else GenNormal_r(arg);
   #endif
        arg->index=0;
    }
    y=arg->u.x[arg->index++];
    y^= y>>SHIFT_0;
    y^=(y<<SHIFT_B)&MASK_B;
    y^=(y<<SHIFT_C)&MASK_C;
    y^= y>>SHIFT_1;
    return y;
}
  #else /* COMPACT -> true */

   #if defined(HAVE_AVX2)
    #if defined(__GNUC__)
     #pragma GCC push_options
     #pragma GCC target("avx2")
    #endif
   #else
    #if defined(__GNUC__)
     #pragma GCC push_options
     #pragma GCC target("sse2")
    #endif
   #endif

INLINE_OR_NOT uint32_t NextMt_r(state_p arg) {
    NO_CPP_INIT
   #if defined(DUAL)
    if (arg->flag)
   #endif
    {
   #if defined(HAVE_AVX2)
        const int mod=arg->index&7;
   #elif defined(HAVE_SSE3) || defined(HAVE_SSE2)
        const int mod=arg->index&3;
   #endif
        if (mod==0) {
            if (arg->index==MT_N) { GenSIMD_r(arg); arg->index=0; }
   #if defined(HAVE_AVX2)
            {
                __m256i u, v;
                u=_mm256_load_si256((__m256i*)&arg->u.x[arg->index]);
                v=_mm256_srli_epi32(u,SHIFT_0);
                u=_mm256_xor_si256(u,v);
                v=_mm256_slli_epi32(u,SHIFT_B);
                v=_mm256_and_si256(v,MskB.a);
                u=_mm256_xor_si256(u,v);
                v=_mm256_slli_epi32(u,SHIFT_C);
                v=_mm256_and_si256(v,MskC.a);
                u=_mm256_xor_si256(u,v);
                v=_mm256_srli_epi32(u,SHIFT_1);
                u=_mm256_xor_si256(u,v);
                _mm256_store_si256((__m256i*)&arg->u.x[MT_N], u);
            }
   #else
            {
                __m128i u,v;
                u=_mm_load_si128((__m128i*)&arg->u.x[arg->index]);
                v=_mm_srli_epi32(u,SHIFT_0);
                u=_mm_xor_si128(u,v);
                v=_mm_slli_epi32(u,SHIFT_B);
                v=_mm_and_si128(v,MskB.m);
                u=_mm_xor_si128(u,v);
                v=_mm_slli_epi32(u,SHIFT_C);
                v=_mm_and_si128(v,MskC.m);
                u=_mm_xor_si128(u,v);
                v=_mm_srli_epi32(u,SHIFT_1);
                u=_mm_xor_si128(u,v);
                _mm_store_si128((__m128i*)&arg->u.x[MT_N],u);
            }
   #endif
        }
        arg->index++;
        return arg->u.x[mod+MT_N];
    }
   #if defined(DUAL)
    else {
        uint32_t y;
        if (arg->index==MT_N)
        { GenNormal_r(arg); arg->index=0; }
        y=arg->u.x[arg->index++];
        y^= y>>SHIFT_0;
        y^=(y<<SHIFT_B)&MASK_B;
        y^=(y<<SHIFT_C)&MASK_C;
        y^= y>>SHIFT_1;
        return y;
    }
   #endif
}
   #if defined(__GNUC__)
    #pragma GCC pop_options
   #endif
  #endif /* COMPACT */
 #else /* EXTEND -> true */
INLINE_OR_NOT uint32_t NextMt_r(state_p arg) {
    NO_CPP_INIT
    if (arg->index==MT_N) {
  #if defined(DUAL)
      if (arg->flag)
  #endif
          GenSIMD_r(arg);
  #if defined(DUAL)
      else GenNormal_r(arg);
  #endif
        arg->index=0;
    }
    return arg->u.x[MT_N+arg->index++];
} 
 #endif /* EXTEND end */
#else /* SIMD -> !SIMD */
 #if !defined(EXTEND)
INLINE_OR_NOT uint32_t NextMt_r(state_p arg) {
    uint32_t y;
    NO_CPP_INIT
    if (arg->index==MT_N) { GenNormal_r(arg); arg->index=0; }
    y=arg->u.x[arg->index++];
    y^= y>>SHIFT_0;
    y^=(y<<SHIFT_B)&MASK_B;
    y^=(y<<SHIFT_C)&MASK_C;
    y^= y>>SHIFT_1;
    return y;
}
 #else
INLINE_OR_NOT uint32_t NextMt_r(state_p arg) {
    NO_CPP_INIT
    if (arg->index==MT_N) { GenNormal_r(arg); arg->index=0; }
    return arg->u.x[arg->index++ +MT_N];
} 
 #endif
#endif /* SIMD end */

#if defined(FAST_UNIF)
INLINE_OR_NOT double NextUnif_r(state_p arg)
{ return NextMt_R(arg)*(1.0/4294967296.0); }
#elif ( defined(ORIGINAL) || defined(OLD_UNIF) ) && !defined(UNIF_52)
INLINE_OR_NOT double NextUnif_r(state_p arg) {
    const uint32_t a=NextMt_R(arg)>>5,b=NextMt_R(arg)>>6;
    return(a*67108864.0+b)*(1.0/9007199254740992.0); 
}
#elif ( ( INT_MAX<=32767 && !defined(UNIF_53) ) || defined(UNIF_52) ) \
       && !defined(NOT_IEEE754__)
INLINE_OR_NOT double NextUnif_r(state_p arg) {
    int_dbl_t x;
    x.u.u1=NextMt_R(arg); x.u.u0=NextMt_R(arg);
    #if INT_MAX > 32767
    x.u.u0>>=7; x.u.u1>>=5; x.u.u0|=x.u.u1<<(32-7); x.u.u1>>=7;
    x.u.u1|=0x3ff00000;
    #else
    x.s.s00=(unsigned short)((x.s.s00>>7)+(x.s.s01<<(16-7))); x.s.s01>>=7;
    x.s.s10=(unsigned short)((x.s.s10>>5)+(x.s.s11<<(16-5))); x.s.s11>>=5;
    x.s.s01|=(unsigned short)(x.s.s10<<(16-7));
    x.s.s10=(unsigned short)((x.s.s10>>7)+(x.s.s11<<(16-7))); x.s.s11>>=7;
    x.s.s11|=0x3ff0;
    #endif
    return x.d-1.0;
}
#elif SYSTEM64
INLINE_OR_NOT double NextUnif_r(state_p arg) {
    const int64_t a=NextMt_R(arg)>>5;
    return((a<<26)+(NextMt_R(arg)>>6))*(1.0/9007199254740992.0); 
}
#else
INLINE_OR_NOT double NextUnif_r(state_p arg) {
    const int32_t a=(int32_t)(NextMt_R(arg)>>5);
    const int32_t b=(int32_t)(NextMt_R(arg)>>6);
    return(a*67108864.0+b)*(1.0/9007199254740992.0); 
}
#endif

#if INT_MAX > 32767
INLINE_OR_NOT uint64_t NextMt64_r(state_p arg) {
    uint64_t a=(uint64_t)NextMt_R(arg)<<32;
    return a+NextMt_R(arg);
}
#endif
